(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@editorjs/code'), require('@editorjs/header'), require('@editorjs/image'), require('@editorjs/link'), require('@editorjs/list'), require('@editorjs/marker'), require('@editorjs/paragraph'), require('@editorjs/simple-image'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('@tinynodes/ngx-editorjs-plugins', ['exports', '@angular/common', '@editorjs/code', '@editorjs/header', '@editorjs/image', '@editorjs/link', '@editorjs/list', '@editorjs/marker', '@editorjs/paragraph', '@editorjs/simple-image', '@angular/core'], factory) :
    (factory((global.tinynodes = global.tinynodes || {}, global.tinynodes['ngx-editorjs-plugins'] = {}),global.ng.common,global.Code,global.Header,global.Image,global.Link,global.List,global.Marker,global.Paragraph,global.SimpleImage,global.ng.core));
}(this, (function (exports,common,Code,Header,Image,Link,List,Marker,Paragraph,SimpleImage,i0) { 'use strict';

    Code = Code && Code.hasOwnProperty('default') ? Code['default'] : Code;
    Header = Header && Header.hasOwnProperty('default') ? Header['default'] : Header;
    Image = Image && Image.hasOwnProperty('default') ? Image['default'] : Image;
    Link = Link && Link.hasOwnProperty('default') ? Link['default'] : Link;
    List = List && List.hasOwnProperty('default') ? List['default'] : List;
    Marker = Marker && Marker.hasOwnProperty('default') ? Marker['default'] : Marker;
    Paragraph = Paragraph && Paragraph.hasOwnProperty('default') ? Paragraph['default'] : Paragraph;
    SimpleImage = SimpleImage && SimpleImage.hasOwnProperty('default') ? SimpleImage['default'] : SimpleImage;

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * This plugin returns the tool settings for a `<code>` block tool for `EditorJS`
     */
    var PluginCode = /** @class */ (function () {
        function PluginCode() {
        }
        /**
         * Returns the `ToolSettings` for this plugin
         */
        /**
         * Returns the `ToolSettings` for this plugin
         * @return {?}
         */
        PluginCode.prototype.plugin = /**
         * Returns the `ToolSettings` for this plugin
         * @return {?}
         */
            function () {
                return Code;
            };
        PluginCode.decorators = [
            { type: i0.Injectable }
        ];
        return PluginCode;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A module that provides the default `EditorJS` `<code>` block tool.
     * See [the GitHub repo](https://github.com/editor-js/code) for API details
     */
    var PluginCodeModule = /** @class */ (function () {
        function PluginCodeModule() {
        }
        PluginCodeModule.decorators = [
            { type: i0.NgModule, args: [{
                        providers: [PluginCode]
                    },] }
        ];
        return PluginCodeModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * This plugin returns the tool settings for a `<h1> - <h6>` block tool for `EditorJS`
     */
    var PluginHeader = /** @class */ (function () {
        function PluginHeader() {
        }
        /**
         * Returns the plugin settings
         */
        /**
         * Returns the plugin settings
         * @return {?}
         */
        PluginHeader.prototype.plugin = /**
         * Returns the plugin settings
         * @return {?}
         */
            function () {
                return Header;
            };
        PluginHeader.decorators = [
            { type: i0.Injectable }
        ];
        return PluginHeader;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A module that provides the default `EditorJS` header block tool.
     * See [the GitHub repo](https://github.com/editor-js/header) for API details
     */
    var PluginHeaderModule = /** @class */ (function () {
        function PluginHeaderModule() {
        }
        PluginHeaderModule.decorators = [
            { type: i0.NgModule, args: [{
                        providers: [PluginHeader]
                    },] }
        ];
        return PluginHeaderModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * This plugin returns the tool settings for a `<h1> - <h6>` block tool for `EditorJS`
     */
    var PluginImage = /** @class */ (function () {
        function PluginImage() {
        }
        /**
         * Returns the plugin settings
         */
        /**
         * Returns the plugin settings
         * @return {?}
         */
        PluginImage.prototype.plugin = /**
         * Returns the plugin settings
         * @return {?}
         */
            function () {
                return Image;
            };
        PluginImage.decorators = [
            { type: i0.Injectable }
        ];
        return PluginImage;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A module that provides the default `EditorJS` `<img>` block tool.
     * See [the GitHub repo](https://github.com/editor-js/image) for API details
     */
    var PluginImageModule = /** @class */ (function () {
        function PluginImageModule() {
        }
        PluginImageModule.decorators = [
            { type: i0.NgModule, args: [{
                        providers: [PluginImage]
                    },] }
        ];
        return PluginImageModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * This plugin returns the tool settings for a `<a>` block tool for `EditorJS`
     */
    var PluginLink = /** @class */ (function () {
        function PluginLink() {
        }
        /**
         * Returns the plugin settings
         */
        /**
         * Returns the plugin settings
         * @return {?}
         */
        PluginLink.prototype.plugin = /**
         * Returns the plugin settings
         * @return {?}
         */
            function () {
                return Link;
            };
        PluginLink.decorators = [
            { type: i0.Injectable }
        ];
        return PluginLink;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A module that provides the default `EditorJS` `<a>` block tool.
     * See [the GitHub repo](https://github.com/editor-js/link) for API details
     */
    var PluginLinkModule = /** @class */ (function () {
        function PluginLinkModule() {
        }
        PluginLinkModule.decorators = [
            { type: i0.NgModule, args: [{
                        providers: [PluginLink]
                    },] }
        ];
        return PluginLinkModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * This plugin returns the tool settings for a `<li>` and `<ol>` block tool for `EditorJS`
     */
    var PluginList = /** @class */ (function () {
        function PluginList() {
        }
        /**
         * Returns the plugin settings
         */
        /**
         * Returns the plugin settings
         * @return {?}
         */
        PluginList.prototype.plugin = /**
         * Returns the plugin settings
         * @return {?}
         */
            function () {
                return List;
            };
        PluginList.decorators = [
            { type: i0.Injectable }
        ];
        return PluginList;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A module that provides the default `EditorJS` `<li>` and `<ol>` block tool.
     * See [the GitHub repo](https://github.com/editor-js/list) for API details
     */
    var PluginListModule = /** @class */ (function () {
        function PluginListModule() {
        }
        PluginListModule.decorators = [
            { type: i0.NgModule, args: [{
                        providers: [PluginList]
                    },] }
        ];
        return PluginListModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * This plugin returns the tool settings for a inline marker tool for `EditorJS`
     */
    var PluginMarker = /** @class */ (function () {
        function PluginMarker() {
        }
        /**
         * Returns the plugin settings
         */
        /**
         * Returns the plugin settings
         * @return {?}
         */
        PluginMarker.prototype.plugin = /**
         * Returns the plugin settings
         * @return {?}
         */
            function () {
                return Marker;
            };
        /**
         * Returns the plugin shortcut
         */
        /**
         * Returns the plugin shortcut
         * @return {?}
         */
        PluginMarker.prototype.shortcut = /**
         * Returns the plugin shortcut
         * @return {?}
         */
            function () {
                return 'CMD+SHIFT+M';
            };
        PluginMarker.decorators = [
            { type: i0.Injectable }
        ];
        return PluginMarker;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A module that provides the default `EditorJS` inline marker tool.
     * See [the GitHub repo](https://github.com/editor-js/marker) for API details
     */
    var PluginMarkerModule = /** @class */ (function () {
        function PluginMarkerModule() {
        }
        PluginMarkerModule.decorators = [
            { type: i0.NgModule, args: [{
                        providers: [PluginMarker]
                    },] }
        ];
        return PluginMarkerModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * This plugin returns the tool settings for a `<p>` block tool for `EditorJS`
     */
    var PluginParagraph = /** @class */ (function () {
        function PluginParagraph() {
        }
        /**
         * Returns the plugin settings
         */
        /**
         * Returns the plugin settings
         * @return {?}
         */
        PluginParagraph.prototype.plugin = /**
         * Returns the plugin settings
         * @return {?}
         */
            function () {
                return Paragraph;
            };
        PluginParagraph.decorators = [
            { type: i0.Injectable }
        ];
        return PluginParagraph;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A module that provides the default `EditorJS` `<p>` block tool.
     * See [the GitHub repo](https://github.com/editor-js/paragraph) for API details
     */
    var PluginParagraphModule = /** @class */ (function () {
        function PluginParagraphModule() {
        }
        PluginParagraphModule.decorators = [
            { type: i0.NgModule, args: [{
                        providers: [PluginParagraph]
                    },] }
        ];
        return PluginParagraphModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * This plugin returns the simple image tool for `<img>` block editor `EditorJS`
     */
    var PluginSimpleImage = /** @class */ (function () {
        function PluginSimpleImage() {
        }
        /**
         * Returns the plugin settings
         */
        /**
         * Returns the plugin settings
         * @return {?}
         */
        PluginSimpleImage.prototype.plugin = /**
         * Returns the plugin settings
         * @return {?}
         */
            function () {
                return SimpleImage;
            };
        PluginSimpleImage.decorators = [
            { type: i0.Injectable }
        ];
        return PluginSimpleImage;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A module that provides the simple image tools for `EditorJS` `<img>` block tool.
     * See [the GitHub repo](https://github.com/editor-js/image) for API details
     */
    var PluginSimpleImageModule = /** @class */ (function () {
        function PluginSimpleImageModule() {
        }
        PluginSimpleImageModule.decorators = [
            { type: i0.NgModule, args: [{
                        providers: [PluginSimpleImage]
                    },] }
        ];
        return PluginSimpleImageModule;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The Injection token for initial plugins as defined in the ngx-editorjs module
     * @type {?}
     */
    var InitialPlugins = new i0.InjectionToken('InitialPlugins');
    /**
     * The injection token for adding plugins via your own application
     * @type {?}
     */
    var UserPlugins = new i0.InjectionToken('UserPlugins');

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The plugin service provides a singleton to store all plugins injected into the application
     * and makes them available for all instances of `EditorJS`
     */
    var NgxEditorJSPluginService = /** @class */ (function () {
        /**
         * When the class is initialized the initial plugins and any user plugins
         * will be passed in and merged and stored in the config map
         * @param initialPlugins Default plugins produced by the module
         * @param userPlugins User plugins injected into the application
         */
        function NgxEditorJSPluginService(initialPlugins, userPlugins) {
            var _this = this;
            /**
             * Object map of the plugin configurations
             */
            this.pluginsMap = {};
            Object.entries(__assign({}, initialPlugins, userPlugins)).forEach(( /**
             * @param {?} __0
             * @return {?}
             */function (_a) {
                var _b = __read(_a, 2), key = _b[0], tool = _b[1];
                return _this.add(key, tool);
            }));
        }
        /**
         * Add a plugin to the store
         * @param key The key for the map to store the plugin
         * @param plugin The plugin instance to add to the service
         */
        /**
         * Add a plugin to the store
         * @param {?} key The key for the map to store the plugin
         * @param {?} plugin The plugin instance to add to the service
         * @return {?}
         */
        NgxEditorJSPluginService.prototype.add = /**
         * Add a plugin to the store
         * @param {?} key The key for the map to store the plugin
         * @param {?} plugin The plugin instance to add to the service
         * @return {?}
         */
            function (key, plugin) {
                this.pluginsMap[key] = plugin;
            };
        /**
         * Remove a plugin from the store
         * @param key
         */
        /**
         * Remove a plugin from the store
         * @param {?} key
         * @return {?}
         */
        NgxEditorJSPluginService.prototype.remove = /**
         * Remove a plugin from the store
         * @param {?} key
         * @return {?}
         */
            function (key) {
                this.pluginsMap[key] = null;
                delete this.pluginsMap[key];
            };
        /**
         * Get a single plugin from the map
         * @param name
         */
        /**
         * Get a single plugin from the map
         * @param {?} key
         * @return {?}
         */
        NgxEditorJSPluginService.prototype.get = /**
         * Get a single plugin from the map
         * @param {?} key
         * @return {?}
         */
            function (key) {
                return this.pluginsMap[key];
            };
        Object.defineProperty(NgxEditorJSPluginService.prototype, "plugins", {
            /**
             * Returns a map of all the plugins registered with this service
             */
            get: /**
             * Returns a map of all the plugins registered with this service
             * @return {?}
             */ function () {
                return this.pluginsMap;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Returns a map of tools to be initialized by the editor
         * @param exclude Optional array of keys to exclude from the map
         */
        /**
         * Returns a map of tools to be initialized by the editor
         * @param {?=} exclude Optional array of keys to exclude from the map
         * @return {?}
         */
        NgxEditorJSPluginService.prototype.getTools = /**
         * Returns a map of tools to be initialized by the editor
         * @param {?=} exclude Optional array of keys to exclude from the map
         * @return {?}
         */
            function (exclude) {
                if (exclude === void 0) {
                    exclude = [];
                }
                return Object.entries(this.pluginsMap)
                    .filter(( /**
             * @param {?} __0
             * @return {?}
             */function (_a) {
                    var _b = __read(_a, 1), key = _b[0];
                    return !exclude.includes(key);
                }))
                    .reduce(( /**
             * @param {?} finalTools
             * @param {?} __1
             * @return {?}
             */function (finalTools, _a) {
                    var _b = __read(_a, 2), key = _b[0], plugin = _b[1];
                    var _c, _d;
                    if (plugin.shortcut) {
                        return __assign((_c = {}, _c[key] = {
                            class: plugin.plugin(),
                            shortcut: plugin.shortcut()
                        }, _c), finalTools);
                    }
                    else {
                        return __assign((_d = {}, _d[key] = plugin.plugin(), _d), finalTools);
                    }
                }), {});
            };
        NgxEditorJSPluginService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        NgxEditorJSPluginService.ctorParameters = function () {
            return [
                { type: undefined, decorators: [{ type: i0.Inject, args: [InitialPlugins,] }] },
                { type: undefined, decorators: [{ type: i0.Optional }, { type: i0.Inject, args: [UserPlugins,] }] }
            ];
        };
        /** @nocollapse */ NgxEditorJSPluginService.ngInjectableDef = i0.defineInjectable({ factory: function NgxEditorJSPluginService_Factory() { return new NgxEditorJSPluginService(i0.inject(InitialPlugins), i0.inject(UserPlugins, 8)); }, token: NgxEditorJSPluginService, providedIn: "root" });
        return NgxEditorJSPluginService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * This module provides the plugin service used by NgxEditorJS.
     */
    var NgxEditorJSPluginServiceModule = /** @class */ (function () {
        function NgxEditorJSPluginServiceModule() {
        }
        NgxEditorJSPluginServiceModule.decorators = [
            { type: i0.NgModule, args: [{
                        providers: [NgxEditorJSPluginService]
                    },] }
        ];
        return NgxEditorJSPluginServiceModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * The `NgxEditorjsPluginsModule` provides several additional modules
     * that provide a way to easily plug in block and inline tools for `EditorJS`.
     *
     * Importing `NgxEditorjsPluginsModule` will include all modules, while it
     * is also possible to import each individual module as required.
     */
    var NgxEditorjsPluginsModule = /** @class */ (function () {
        function NgxEditorjsPluginsModule() {
        }
        NgxEditorjsPluginsModule.decorators = [
            { type: i0.NgModule, args: [{
                        imports: [
                            common.CommonModule,
                            PluginCodeModule,
                            PluginHeaderModule,
                            PluginImageModule,
                            PluginLinkModule,
                            PluginListModule,
                            PluginMarkerModule,
                            PluginParagraphModule,
                            PluginSimpleImageModule,
                            NgxEditorJSPluginServiceModule
                        ],
                        exports: [
                            PluginCodeModule,
                            PluginHeaderModule,
                            PluginImageModule,
                            PluginLinkModule,
                            PluginListModule,
                            PluginMarkerModule,
                            PluginParagraphModule,
                            PluginSimpleImageModule,
                            NgxEditorJSPluginServiceModule
                        ]
                    },] }
        ];
        return NgxEditorjsPluginsModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.NgxEditorjsPluginsModule = NgxEditorjsPluginsModule;
    exports.PluginCodeModule = PluginCodeModule;
    exports.PluginCode = PluginCode;
    exports.PluginHeaderModule = PluginHeaderModule;
    exports.PluginHeader = PluginHeader;
    exports.PluginImageModule = PluginImageModule;
    exports.PluginImage = PluginImage;
    exports.PluginLinkModule = PluginLinkModule;
    exports.PluginLink = PluginLink;
    exports.PluginListModule = PluginListModule;
    exports.PluginList = PluginList;
    exports.PluginMarkerModule = PluginMarkerModule;
    exports.PluginMarker = PluginMarker;
    exports.PluginParagraphModule = PluginParagraphModule;
    exports.PluginParagraph = PluginParagraph;
    exports.PluginSimpleImageModule = PluginSimpleImageModule;
    exports.PluginSimpleImage = PluginSimpleImage;
    exports.NgxEditorJSPluginService = NgxEditorJSPluginService;
    exports.InitialPlugins = InitialPlugins;
    exports.UserPlugins = UserPlugins;
    exports.ɵa = NgxEditorJSPluginServiceModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=tinynodes-ngx-editorjs-plugins.umd.js.map